<?php


function gp_get_wp_galleries() {

	$args = array( 'post_type' => 'post', 'numberposts' => -1, 'post_status' => null, 'post_parent' => null); 
	$albums = get_posts( $args );
	$results = array();
	$inc = 0;
	if ($albums) {
		foreach ( $albums as $post ) {
				setup_postdata($post);
				$gp_has_images = GPFunctions::wp_attachment_count($post->ID,'image');
				if ($gp_has_images >=3 ) {
					$results[$inc++] = array('post_id' =>$post->ID,'title'=>substr(get_the_title($post->ID),0,60).' ('.$gp_has_images.')','source'=>'WP Post: ');	
				}
		}
	}


	$args = array( 'post_type' => 'page', 'numberposts' => -1, 'post_status' => null, 'post_parent' => null); 
	$albums = get_posts( $args );
	if ($albums) {
		foreach ( $albums as $post ) {
				setup_postdata($post);
				$gp_has_images = GPFunctions::wp_attachment_count($post->ID,'image');
				if ($gp_has_images >=3 ) {
					$results[$inc++] = array('post_id' =>$post->ID,'title'=>substr(get_the_title($post->ID),0,60).' ('.$gp_has_images.')','source'=>'WP Page: ');	
				}
		}
	}


	
	return $results;
}

/* -----------------------------------------------------------------------------------

Function to get the image data for selected album

----------------------------------------------------------------------------------- */

function gp_get_wp_gallery($album,$leaf) {
$order_by = (!$leaf['options']['gp-order-by']) ? 'title' : $leaf['options']['gp-order-by'];
$order_az = (!$leaf['options']['gp-order-az']) ? 'ASC' : $leaf['options']['gp-order-az'];

// $args = array( 'post_type' => 'attachment', 'numberposts' => -1, 'post_status' => null, 'post_parent' => $album, 'orderby' => $order_by, 'order' => $order_az); 
$args = array( 'post_type' => 'attachment', 'numberposts' => -1, 'post_status' => null, 'post_parent' => $album, 'orderby' => 'title', 'order' => 'ASC'); 
$attachments = get_posts( $args );
$results = array();
$inc = 0;
if ($attachments) {
	foreach ( $attachments as $post ) {
			setup_postdata($post);
			$height = $leaf['options']['gp-image-height'];			
			$width = $leaf['options']['gp-image-width'];
			$image_size = max($leaf['options']['gp-image-height'],$leaf['options']['gp-image-width']);
			$image_src = wp_get_attachment_image_src( $post->ID, 'full');
			$results[$inc] = array('post_id' =>$post->ID,'title'=>get_the_title($post->ID),'caption'=>$attachments[$inc]->post_excerpt,'thumb_url'=>wp_get_attachment_thumb_url($post->ID),'image_url'=>$image_src[0]);
			$inc++;
	}
}
return $results;

}

