<?php


/*


*/



function gp_build_accordion_gallery($leaf) {
	$return_html = '';
	// this will be switch:cased
	$gp_selected_gallery = $leaf['options']['gp-album'];
	$gp_using_source = substr($leaf['options']['gp-album'],0,7);
	if ($leaf['options']['gp-nav-pos'] == 'none' && $leaf['options']['gp-circular'] && $leaf['options']['gp-auto']) {
		$leaf['options']['gp-shownavitems'] = 0;	
	}

	$gp_images = false;
	$gp_gallery_fail = 'insufficient_images';

	$gp_process = GPFunctions::process_gallery($leaf,$gp_using_source);
	$gp_selected_gallery = $gp_process[0]; 
	$gp_images = $gp_process[1];
	$gp_source_id = $gp_process[2];
	$gp_gallery_fail = $gp_process[3];

	
	$gp_no_caption = (!$gp_data['caption'])  ? ' no-caption ' : '';	
	$gp_gallery_source = $gp_source_id.$gp_selected_gallery;


	if (!$gp_images) {return '<div id="grid-gallery-'.$leaf['id'].'">No image in selected gallery. Please add some or select another gallery</div>';}
	

	$image_width = $leaf['options']['gp-image-width'];
	$image_height = $leaf['options']['gp-image-height'];

	$grid_width_css = (!$leaf['options']['gp-scroll-thumbs-hz']) ? '' : 'width:'.(($leaf['options']['gp-thumb-width']+$leaf['options']['gp-panel-padding'])* sizeof($gp_images)).'px;overflow-x:auto;';
	
	$gp_type = '';
	$gp_navpos = '';
	$gp_movepanel = '';
	$gp_movetext = '';
	$gp_height ='';
	$gp_nav_width_css = '';
	$gp_nav_width = 95;
	$gp_prev_loc ='';
	$gp_next_loc = '';
	$gp_rev = (!$leaf['options']['gp-invert-buttons']) ? '' : ' rev';
	$thumb_id= 0;
	$image_id = 0;
	$gp_thumb_padding_val = (!$leaf['options']['gp-pad-between-thumbs']) ? 0 : ($leaf['options']['gp-panel-padding']/2);
	$gp_thumb_padding = 'padding:'.$gp_thumb_padding_val.'px;';

	//Build lightbox settings
	$return_html .= '<div id="accordion-gallery-'.$leaf['id'].'" class="accordion">';
	$return_html .= '<ol class="accordion-thumbs">';
					foreach ($gp_images as $gp_data){
	$return_html .= '<li>';
						$thumb_id++;
						$thumb_src = GPFunctions::generate_image($leaf,$gp_data['image_url'], $leaf['options']['gp-thumb-width'], $leaf['options']['gp-thumb-height'], $leaf['options']['gp-vertical-crop-align'],$leaf['options']['gp-horizontal-crop-align'],$gp_source_id.'thm'.$thumb_id, $leaf['id'],'crop',$leaf['options']['gp-quality'],$leaf['options']['gp-panelbgcolour'],false);
						$image = '<img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/>';
						if ($gp_data['caption']) {
							$image = '<figure><img src="'.$thumb_src['new_image_url'].'"  alt="'.$gp_data['title'].'"/><figcaption>'.$gp_data['caption'].'</figcaption></figure>';
						}
		switch($leaf['options']['gp-link-to']) {

			case 'lightbox':
	$return_html .= '		<h2><span>'.$gp_data['title'].'</span></h2>';
	$return_html .= '		<div class="image-link"><a href="'.$gp_data['image_url'].'" rel="prettyPhoto-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.str_replace('"','&#8221;',$gp_data['caption']).'">';
	$return_html .= $image;
	$return_html .= '						</a>';
	$return_html .= '		</div>';
				break;

			case 'url':
	$return_html .= '		<h2><span>'.$gp_data['title'].'</span>';
	$return_html .= '		<div class="image-link"><a href="'.$gp_data['link_url'].'" rel="image-'.$leaf['id'].'['.$gp_gallery_source.']" title="'.$gp_data['caption'].'">';
	$return_html .= $image;
	$return_html .= '						</a></div>';
				break;


			case 'none':
	$return_html .= '		<h2><span>'.$gp_data['title'].'</span>';
	$return_html .= '		<b>'.$gp_data['caption'].'</b></h2>';
	$return_html .= '		<div class="image-link">'.$image.'</div>';
				break;
		}				
	$return_html .=	'	</li>';
									}
	$return_html .=	'	</ol>';
	$return_html .= '</div>';	
	

	return $return_html;
}

function gp_scripts_gallery_accordion($leaf){
	$return_js = "";
	$slidespeed =	$leaf['options']['gp-accordion-slidespeed']*1000;               // speed of slide animation (time/ms)
	$autoplay =	 	(!!$leaf['options']['gp-accordion-autoplay'])? 'true' : 'false';               // automatically scroll through the slides, if true with pause on user click (boolean)
	$pauseonhover =	(!!$leaf['options']['gp-accordion-pauseonhover'])? 'true' : 'false';           // *NEW in 1.1* - pause slides on hover
	$cyclespeed =	$leaf['options']['gp-accordion-cyclespeed']*1000;              // time between slide activation (time/ms)
	$theme =		$leaf['options']['gp-accordion-theme'];                // which theme to use ('basic', 'light'*, 'dark', or 'stitch'*)
	$rounded = 		(!!$leaf['options']['gp-accordion-rounded'])? 'true' : 'false';                // whether to use rounded corners or not** (boolean)
	$enumerate =	(!!$leaf['options']['gp-accordion-enumerateslides'])? 'true' : 'false';         // show slide number in tab			
	$frame_height = $leaf['options']['gp-frame-height']-2*$leaf['options']['gp-frame-padding'];
	$frame_width = 	$leaf['options']['gp-frame-width']-2*$leaf['options']['gp-frame-padding'];
	$tab_width = 	$leaf['options']['gp-accordion-tabwidth'];
	$return_js .= "
		jQuery(document).ready(function (){
			jQuery('#accordion-gallery-".$leaf['id']."').liteAccordion({
				containerWidth : ".$frame_width.",           // width of accordion (px)
				containerHeight : ".$frame_height.",          // height of accordion (px)
				headerWidth : ".$tab_width.",               // width of tabs (px)
				 
				firstSlide : 1,                 // number of the first active slide (integer)
				onActivate : function() {},     // callback function triggered on tab click/mouseover (function)
				slideSpeed : ".$slidespeed.",               // speed of slide animation (time/ms)
				slideCallback : function() {},  // callback function triggered after slide animation is complete (function)
				 
				autoPlay : ".$autoplay.",               // automatically scroll through the slides, if true with pause on user click (boolean)
				pauseOnHover :".$pauseonhover.",           // *NEW in 1.1* - pause slides on hover
				cycleSpeed : ".$cyclespeed.",              // time between slide activation (time/ms)
				 
				theme : '".$theme."',                // which theme to use ('basic', 'light'*, 'dark', or 'stitch'*)
				rounded : ".$rounded.",                // whether to use rounded corners or not** (boolean)
				enumerateSlides : ".$enumerate.",         // show slide number in tab			
			    onActivate : function() {
			        this.find('figcaption').fadeOut();
			    },
			    slideCallback : function() {    
			        this.find('figcaption').fadeIn();
			    },
			
			}).find('figcaption:first').show();
		});	
	";	
	
	
	// Other js
	
	if ($leaf['options']['gp-link-to'] == 'lightbox') {	
		// prettyPhoto js
		$gp_lb_auto =  ($leaf['options']['gp-lb-auto'] != false) ? 'true' : 'false';
	//	$gp_lb_circular = ($leaf['options']['gp-lb-circular'] != false) ? 'true' : 'false';
		$gp_lb_showfor = ($leaf['options']['gp-lb-showfor']*1000);
		$gp_lb_style = (!$leaf['options']['gp-lb-style']) ? 'pp_default' : $leaf['options']['gp-lb-style'];
	
		$social_code = '<div class="pp_social"><div class="twitter"><a href="http://twitter.com/share" class="twitter-share-button" data-count="none">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div><div class="facebook"><iframe src="http://www.facebook.com/plugins/like.php?locale=en_US&href=\'+location.href+\'&amp;layout=button_count&amp;show_faces=true&amp;width=500&amp;action=like&amp;font&amp;colorscheme=light&amp;height=23" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:500px; height:23px;" allowTransparency="true"></iframe></div></div>';
		$gp_lb_social = ($leaf['options']['gp-lb-social'] != false) ? $social_code : false;
		$gp_lb_style = $leaf['options']['gp-lb-style'];
		$gp_lb_deeplink = ($leaf['options']['gp-lb-social'] != false) ? 'true' : 'false';
		$gp_lb_opacity = $leaf['options']['gp-lb-bg-opacity'];
		$gp_lb_bgcolour = $leaf['options']['gp-lb-background'];
		
	
		$return_js .= " 
				jQuery(document).ready(
					function (){
							jQuery(\"a[rel^='prettyPhoto-".$leaf['id']."']\").prettyPhoto(
								{
									social_tools:'".$gp_lb_social."',
									opacity: '".$gp_lb_opacity."',
									animation_speed: 'normal',
									autoplay_slideshow: ".$gp_lb_auto.",
									deeplinking: ".$gp_lb_deeplink.",
									slideshow:".$gp_lb_showfor.",
									theme:'".$gp_lb_style."',
									backgcolor: '".$gp_lb_bgcolour."'
									
								}
							);
						}
					);
			";
	}	

	return $return_js;
}

function gp_leaf_options_accordion($leaf){
	/* Set default values */
	$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	$show_tabs = array();
		
		$show_tabs = 	array(
			'images' => 'Images',
			'frame' =>	'Frame',
			'settings' => 'Settings',
			'lightbox' => 'Lightbox',
			'miscellaneous' => 'Miscellaneous'
		);

		HeadwayLeafsHelper::create_tabs($show_tabs, $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<a href="'.GP_COLOUR_PICKER.'" target=_blank>Online Color Code Generator Tool</a><br />
		</td>
	</tr>';

	$leaf['type'] = 'gallery-plus-accordion';

	gp_options_images_accordion($leaf);	
	gp_options_frame($leaf);	
	gp_options_settings_accordion($leaf);
	gp_options_lightbox($leaf);	
	gp_options_misc($leaf);	

}

/* 	==============================================================================================================================
	 ACCORDION OPTIONS
	============================================================================================================================== */

function gp_options_settings_accordion($leaf) {
	if($leaf['new']){
		$leaf['options']['gp-accordion-slidespeed'] = 0.8;               // speed of slide animation (time/ms)
		$leaf['options']['gp-accordion-autoplay'] = true;               // automatically scroll through the slides, if true with pause on user click (boolean)
		$leaf['options']['gp-accordion-pauseonhover'] = true;           // *NEW in 1.1* - pause slides on hover
		$leaf['options']['gp-accordion-cyclespeed'] = 6;              // time between slide activation (time/ms)
		$leaf['options']['gp-accordion-theme'] = 'dark';                // which theme to use ('basic', 'light'*, 'dark', or 'stitch'*)
		$leaf['options']['gp-accordion-rounded'] = false;                // whether to use rounded corners or not** (boolean)
		$leaf['options']['gp-accordion-enumerateslides'] = true;         // show slide number in tab			
		$leaf['options']['gp-accordion-tabwidth'] = 48;

	}

	HeadwayLeafsHelper::open_tab('settings', $leaf['id']);
		// Slide speed
		$title = 'Slide speed';
		$tooltip = 'Speed of slide animation in seconds';
		$default = 'Default: 0.8';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-accordion-slidespeed', 'value' => $leaf['options']['gp-accordion-slidespeed'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


		// Autoplay
		$title = 'Auto play';
		$tooltip = 'Option to enable auto play so images change automatically';
		$default = 'Default: On';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-accordion-autoplay', 'value' => $leaf['options']['gp-accordion-autoplay'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Pause on hover
		$title = 'Pause on hover';
		$tooltip = 'Option to pause the autoplay when mouse hovers over the images';
		$default = 'Default: On';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-accordion-pauseonhover', 'value' => $leaf['options']['gp-accordion-pauseonhover'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Cycle speed
		$title = 'Cycle speed';
		$tooltip = 'Time between slide activation in seconds';
		$default = 'Default: 6';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-accordion-cyclespeed', 'value' => $leaf['options']['gp-accordion-cyclespeed'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Theme
		$gp_accordion_theme = array(
			'dark' => 'Dark',
			'basic' => 'Basic',
			'acc-custom' => 'Custom'
		);
		$title = 'Theme';
		$tooltip = 'Choose a theme for the accordion. You can create you own custom theme too. See the use guide.';
		$default = 'Default: Dark';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-accordion-theme', 'value' => $leaf['options']['gp-accordion-theme'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_accordion_theme, 'no-border'=>true), $leaf['id']);

		// Rounded
		$title = 'Rounded Dark Theme';
		$tooltip = 'Whether to use rounded corners or not on the Dark theme';
		$default = 'Default: Off';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-accordion-rounded', 'value' => $leaf['options']['gp-accordion-rounded'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Number slides
		$title = 'Number images';
		$tooltip = 'Option to show images number on each tab';
		$default = 'Default: On';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-accordion-enumerateslides', 'value' => $leaf['options']['gp-accordion-enumerateslides'], 'left-label' => gp_option_label($title,$tooltip,$default,'right'), 'checkbox-label' => ''), $leaf['id']);

		// Tab width
		$title = 'Tab width (px)';
		$tooltip = 'Sets the width of each image\'s title tab';
		$default = 'Default: 48';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-accordion-tabwidth', 'value' => $leaf['options']['gp-accordion-tabwidth'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

	HeadwayLeafsHelper::close_tab();
}

function gp_options_images_accordion($leaf) {
	if($leaf['new']){
		// Images
		$leaf['options']['gp-album'] = 'Samples: 98989898';
		$leaf['options']['gp-order-az'] = 'ASC';
		$leaf['options']['gp-order-by'] = 'title';
		$leaf['options']['gp-link-to'] = 'lightbox';
		$leaf['options']['gp-recreate-images']	= false;
		$leaf['options']['gp-thumb-height'] = '300';
		$leaf['options']['gp-thumb-width'] = '500';
		$leaf['options']['gp-vertical-crop-align'] = 'center';
		$leaf['options']['gp-horizontal-crop-align'] = 'center';
		$leaf['options']['gp-quality'] = '70';
		$leaf['options']['gp-image-captions'] = true;
	}
	/// ------------------------------------------------
	// Images accordion tab					   -----------------
	/// ------------------------------------------------
	HeadwayLeafsHelper::open_tab('images', $leaf['id']);

		/* Album */
		/* Create a list of all galleries in G+, HW and NG prefixed with their source name */
		$gp_albums = GPFunctions::get_galleries(); // Located in gp_functions.php
		$gp_album_list = array();
		$gp_album_list[0] = 'No gallery selected';
		foreach ($gp_albums as $albums) {
			$gp_album_list[$albums['source'].$albums['post_id']] = $albums['source'].$albums['title'];
		}
		$title = 'Gallery';
		$tooltip = 'Select a gallery of images to display';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-album', 'value' => $leaf['options']['gp-album'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_album_list), $leaf['id']);

		// Image Width
		$title = 'Image Width';
		$tooltip = 'Sets the width of the images in pixels';
		$default = 'Default: 300';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-width', 'value' => $leaf['options']['gp-thumb-width'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Image height
		$title = 'Image Height';
		$tooltip = 'Sets the height of the images in pixels';
		$default = 'Default: 500';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-thumb-height', 'value' => $leaf['options']['gp-thumb-height'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);

		// Order by
		$gp_order_by = array(
				'title' => 'Title',
				'ID' => 'Order added',
				'rand' => 'Random'
			);
		$title = 'Order By';
		$tooltip = 'Set what info you\'d like to order the images by. Note: Some galleries plugins may not support this.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-order-by', 'value' => $leaf['options']['gp-order-by'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_order_by), $leaf['id']);

		/* Vertical crop alignment */
		$vertical_crop_align = array(
				'center' => 'Center',
				'top' => 'Top',
				'topquarter' => 'Top quarter',
				'bottomquarter' => 'Bottom quarter',
				'bottom' => 'Bottom'
			);

		$title = 'Vertical Crop Alignment';
		$tooltip = 'Choose how you want to vertically align the main image when it crops.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-vertical-crop-align', 'value' => $leaf['options']['gp-vertical-crop-align'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $vertical_crop_align), $leaf['id']);

		/* Horizontal crop alignment */
		$horizontal_crop_align = array(
				'center' => 'Center',
				'left' => 'Left',
				'leftquarter' => 'Left quarter',
				'rightquarter' => 'Right quarter',
				'right' => 'Right'
			);
		$title = 'Horizontal Crop Alignment';
		$tooltip = 'Choose how you want to horizontally align the main image when it crops';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-horizontal-crop-align', 'value' => $leaf['options']['gp-horizontal-crop-align'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $horizontal_crop_align), $leaf['id']);


		// Compression
		$title = 'Image quality';
		$tooltip = 'Lower values will reduce the size of the file but also the clarity of the image. Higher values will make images slower loading.<br/>Value range is 0 to 100.';
		$default = 'Default: 70';
		HeadwayLeafsHelper::create_text_input(array('name' => 'gp-quality', 'value' => $leaf['options']['gp-quality'], 'label' => gp_option_label($title,$tooltip,$default,'right')), $leaf['id']);


		// Order
		$gp_order_az = array(
				'ASC' => 'Ascending',
				'DESC' => 'Descending'
			);
		$title = 'Order';
		$tooltip = 'Sets the order of the images, either ascending or descending. Note: Some galleries plugins may not support this.';
		$default = '';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-order-az', 'value' => $leaf['options']['gp-order-az'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_order_az, 'no-border'=>true), $leaf['id']);

		// Link to
		$gp_link_to = array(
				'lightbox' => 'Lightbox',
				'url' => 'URL',
				'none' => 'Do nothing'
			);
		$title = 'Link to on image click';
		$tooltip = 'Action on image click. <br/><strong>If you choose URL, you will need to enter the required URL in the descriptiuon field of the images in the selected G+ gallery.</strong>';
		$default = 'Default: Lightbox';
		HeadwayLeafsHelper::create_select(array('name' => 'gp-link-to', 'value' => $leaf['options']['gp-link-to'], 'label' => gp_option_label($title,$tooltip,$default,'right'), 'options' => $gp_link_to, 'no-border'=>true), $leaf['id']);

		// Show image captions
		$title = 'Show image captions';
		$tooltip = 'Option to show or hide the image captions. They will appear superimposed on the image;';
		$default = 'Default: On';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-image-captions', 'value' => $leaf['options']['gp-image-captions'], 'left-label' =>   gp_option_label($title, $tooltip, $default, 'right') , 'checkbox-label' => ''), $leaf['id']);


		// Recreate all images on publish or refresh
		$title = 'Do not recreate images for this leaf';
		$tooltip = 'By default, this leaf\'s images will be recreated when publishing or refreshing in the Visual Editor. <br/>Once you are happy with the images for this leaf, then check this so they don\'t get rereated each time. <br/> This has no effect other than saving the time it takes to reload the Visual Editor.';
		$default = '';
		HeadwayLeafsHelper::create_checkbox(array('name' => 'gp-recreate-images', 'value' => $leaf['options']['gp-recreate-images'], 'left-label' =>   gp_option_label($title, $tooltip, $default, 'right') , 'checkbox-label' => ''), $leaf['id']);

	echo '
	<tr>
		<td colspan="2">
			<span class="hilite">If your images are causing an out of memory error, pleease reduce their size, or increase your system\'s PHP memory limit.<br/>On websites, there is generally no need to hve images any larger than 1000x1000px.</span>
		</td>
	</tr>
	';


		if (!function_exists( 'exif_imagetype' )) {	
			echo '<p class="gp-warning"><strong>Note:</strong> Your host\'s server does not have the PHP function exif_imagetype() enabled that is used for image validation. G+ has to use the much slower getimagesize() instead. This might cause the leaf to run noticeably slower.</p>';
		}
	HeadwayLeafsHelper::close_tab();

}

