<?php
/*
Functions
gp_get_gp_album_name($leaf)
gp_get_gp_galleries()
gp_get_gp_gallery($album,$leaf)
*/


/* Get the source to an array 
List in HTML
shove into gallery style

start with G+ gallery and Gallery plugin.
*/



function gp_get_gp_galleries() {

	$args = array( 'post_type' => 'gp_gallery', 'numberposts' => -1, 'post_status' => null, 'post_parent' => null); 
	$albums = get_posts( $args );
	$results = array();
	$inc = 0;
	if ($albums) {
		foreach ( $albums as $post ) {
				setup_postdata($post);
				$results[$inc++] = array('post_id' =>$post->ID,'title'=>get_the_title($post->ID).' ('.GPFunctions::wp_attachment_count($post->ID,'image').')','source'=>'Gallery+: ');	
		}
	}
	return $results;
}

/* -----------------------------------------------------------------------------------

Function to get the image data for selected album

----------------------------------------------------------------------------------- */

function gp_get_gp_gallery($album,$leaf) {
$order_by = (!$leaf['options']['gp-order-by']) ? 'title' : $leaf['options']['gp-order-by'];
$order_az = (!$leaf['options']['gp-order-az']) ? 'ASC' : $leaf['options']['gp-order-az'];

// $args = array( 'post_type' => 'attachment', 'numberposts' => -1, 'post_status' => null, 'post_parent' => $album, 'orderby' => $order_by, 'order' => $order_az); 
$args = array( 'post_type' => 'attachment', 'numberposts' => -1, 'post_status' => null, 'post_parent' => $album, 'orderby' => 'title', 'order' => 'ASC'); 
$attachments = get_posts( $args );
$results = array();
$inc = 0;
if ($attachments) {
	foreach ( $attachments as $post ) {
			setup_postdata($post);
			$height = $leaf['options']['gp-image-height'];			
			$width = $leaf['options']['gp-image-width'];
			$image_size = max($leaf['options']['gp-image-height'],$leaf['options']['gp-image-width']);
			$image_src = wp_get_attachment_image_src( $post->ID, 'full');

//			$image_src = wp_get_attachment_image_src( $post->ID, array($image_size,$image_size));
//			var_dump($image_src);
//			echo '<hr/>';

			$results[$inc] = array(
				'post_id' =>$post->ID,
				'title'=>stripslashes(get_the_title($post->ID)),
				'caption'=>stripslashes($attachments[$inc]->post_excerpt),
				'thumb_url'=>wp_get_attachment_thumb_url($post->ID),
				'image_url'=>$image_src[0],
				'link_url'=>$attachments[$inc]->post_content
				);
			$inc++;
	}
}
return $results;

}
