<?php
/*
Function list:
	gp_get_source_albums()
	gp_generate_image($source,$target_width,$target_height, $vertical_crop_align, $horizontal_crop_align, $image_id, $leafid)
	gp_parse_meta($leaf,$meta)
	gp_shortcode( $atts, $content=null, $code="" )
*/
class GPFunctions {
	function initialize_gallery_plugins($leaf){
	/*
	debug($leaf);
		switch ($leaf['type']) {
			case 'gallery-plus':
	*/
				// SliderKit
				wp_enqueue_style( 'sliderkit-core-css', GP_STYLES_URL.'/js/sliderkit/lib/css/sliderkit-core.css');
				wp_enqueue_style( 'sliderkit-layouts-css', GP_STYLES_URL.'/js/sliderkit/lib/css/sliderkit-layouts.css');
				wp_enqueue_style( 'sliderkit-ie-css', GP_STYLES_URL.'/js/sliderkit/lib/css/sliderkit-ie.css');
				wp_enqueue_script('sliderkit', GP_STYLES_URL.'/js/sliderkit/lib/js/jquery.sliderkit.1.5.1.js');
	/*
				break;
	
			case 'gallery-plus-carousel':
	*/
				// Cloud carousel
				wp_enqueue_script('cloudcarousel-js', GP_STYLES_URL.'/js/cloud-carousel.1.0.5/cloud-carousel.1.0.5.min.js');
				wp_enqueue_style( 'cloudcarousel-css', GP_STYLES_URL.'/js/cloud-carousel.1.0.5/cloud-carousel.css');
	/*
				break;
		
			case 'gallery-plus-grid':
	*/
				// Grid
				wp_enqueue_style( 'thumbgrid-css', GP_STYLES_URL.'/js/thumbgrid/thumbgrid.css');
	/*
				break;
			
	
			case 'gallery-plus-galleriffic':
	*/
	/*
				wp_enqueue_script('galleriffic-js', GP_STYLES_URL.'/js/galleriffic/js/jquery.galleriffic.js');
				wp_enqueue_script('galleriffic-history-js', GP_STYLES_URL.'/js/galleriffic/js/jquery.history.js');
				wp_enqueue_script('galleriffic-opacityrollover-js', GP_STYLES_URL.'/js/galleriffic/js/jquery.opacityrollover.js');
				wp_enqueue_style( 'galleriffic-css', GP_STYLES_URL.'/js/galleriffic/css/galleriffic-2.css');
	*/
	/*
				break;
	
			case 'gallery-plus-accordion':
	*/
				wp_enqueue_script('accordion-js', GP_STYLES_URL.'/js/nikki-liteAccordion/js/liteaccordion.jquery.js');
				wp_enqueue_style( 'accordion-css', GP_STYLES_URL.'/js/nikki-liteAccordion/css/liteaccordion.css');
	/*
				break;
	
	
	
		}
	*/
		//<!-- Add-ons -->
		// (Should move this one to JS)
		wp_enqueue_script('sliderkit-easing', GP_JS_URL.'/jquery.easing.1.3.min.js');
		wp_enqueue_script('sliderkit-mousewheel', GP_JS_URL.'/jquery.mousewheel.min.js');
	
		// Pretty photo
		wp_enqueue_script('prettyphoto-js', GP_JS_URL.'/prettyPhoto/js/jquery.prettyPhoto.js');
		wp_enqueue_style( 'prettyphoto-css', GP_JS_URL.'/prettyPhoto/css/prettyPhoto.css');
	
		// Cloud zoom
		wp_enqueue_script('cloudzoom-js', GP_JS_URL.'/cloud-zoom/cloud-zoom.1.0.2.min.js');
		wp_enqueue_style( 'cloudzoom-css', GP_JS_URL.'/cloud-zoom/cloud-zoom.css');
	
		// jQuery Tools 
		wp_enqueue_script('jquerytools-js', GP_JS_URL.'/jquery.tools/jquery.tools.min.js');
		wp_enqueue_style( 'jquerytools-css', GP_JS_URL.'/jquery.tools/jquery.tools.css');
	
	}
	
	
	function get_galleries() {
	
	// We need to look for each source and load any galleries in it
	
		// Gallery+
		$gp_results = array();
		$gp_results = gp_get_gp_galleries();
	
		// WordPress
		$wp_results = array();
		$wp_results = gp_get_wp_galleries();
		$wp_single = array();	
		$wp_single[0] = array('post_id' =>99999999,'title'=>'Use images in viewed post/page (min 3 images)','source'=>'Content: ');	
	
	
		// Sample
		$gp_sample_results = array();
		$gp_sample_results = gp_get_sample_gallery();
	
		// Headway
		$hw_results = array();
		if (function_exists('headway_register_gallery_leaf')) {
			$hw_results = gp_get_hw_galleries(); // located in galleries/hw_gallery_functions.php
		}
	
		// NextGen	
		$ng_results = array();
		if (class_exists('nggloader')) {
			$ng_results = gp_get_ng_galleries(); // located in galleries/ng_gallery_functions.php
		}
	
	
		$return_array = array_merge($gp_results,$hw_results,$ng_results,$wp_single,$wp_results,$gp_sample_results);
		return $return_array;
	}
	
	function process_gallery($leaf,$gp_using_source) {
		$return_array = array();
		$gp_selected_gallery = ''; 
		$gp_images = '';
		$gp_source_id = '';
		$gp_gallery_fail = '';
	
		switch ($gp_using_source) {
		
			case 'Gallery':
				$gp_selected_gallery = str_replace('Gallery+: ','',$leaf['options']['gp-album']);
				$gp_images = gp_get_gp_gallery($gp_selected_gallery, $leaf);
				$gp_source_id = "gp";
				break;
	
			case 'WP Post':
				$gp_selected_gallery = str_replace('WP Post: ','',$leaf['options']['gp-album']);
				$gp_images = gp_get_wp_gallery($gp_selected_gallery, $leaf);
				$gp_source_id = "wp";
				break;
	
			case 'WP Post':
				$gp_selected_gallery = str_replace('WP Post: ','',$leaf['options']['gp-album']);
				$gp_images = gp_get_wp_gallery($gp_selected_gallery, $leaf);
				$gp_source_id = "wp";
				break;
	
			case 'Content':
				if (GPFunctions::wp_attachment_count(get_the_ID(),'image') >= 3) {
					$gp_images = gp_get_wp_gallery(get_the_ID(), $leaf);
					$gp_source_id = "wc";
				} else {
					$gp_gallery_fail = 'no_content_gallery';
				}
				break;
	
	
			case 'Samples':
				$gp_selected_gallery = str_replace('Samples: ','',$leaf['options']['gp-album']);
				$gp_images = gp_get_gp_sample_gallery($gp_selected_gallery, $leaf);
				$gp_source_id = "sm";
				break;
			
			case 'Headway':
				$gp_selected_gallery = str_replace('Headway PhotoGallery: ','',$leaf['options']['gp-album']);
				$gp_images = gp_get_hw_gallery($gp_selected_gallery, $leaf);
				$gp_source_id = "hw";
				break;
			
			case 'NextGen':
				$gp_selected_gallery = str_replace('NextGen Gallery: ','',$leaf['options']['gp-album']);
				$gp_images = gp_get_ng_gallery($gp_selected_gallery, $leaf);
				$gp_source_id = "ng";
				break;
	
		}
		$return_array = array($gp_selected_gallery,$gp_images,$gp_source_id,$gp_gallery_fail);
		return $return_array;
	}
	
	
	function generate_image($leaf,$source,$target_width,$target_height, $vertical_crop_align, $horizontal_crop_align, $image_id, $leafid, $sizing_type, $img_quality, $img_bg_colour, $centre_image){
	
	// $leaf added above later, so some unnecessary parameters
	
		// THIS NEEDS TO BE FIXED WITH CHECKS IN E+
		/* We really only want to generate images when in VE */
		$try_to_create_again = false;
	
		/* This line accommodates nextgen too, making sure it uses the full image */
		$image_url = str_replace('thumbs/thumbs_','',$source);
	
		// Not all servers support looking for URL, so we need the path.
		$image_shortname = str_replace((home_url().'/wp-content'),'',$image_url);
		$image_home_path = WP_CONTENT_DIR;
		$image_path = $image_home_path.$image_shortname;
	
		$img_bg_colour = substr($img_bg_colour,1);
		$img_bg_colour = (strlen($img_bg_colour)==3) ? $img_bg_colour.$img_bg_colour:$img_bg_colour;
	
		$new_image_url = GP_CACHE_URL_PREFIX.'leaf-'.$leafid.'-image-'.$image_id.'.jpg';
		$new_image_path = GP_CACHE_PATH_PREFIX.'leaf-'.$leafid.'-image-'.$image_id.'.jpg';
		if (!headway_visual_editor_open()) {
		
			$image_src = '<img src="'.$new_image_url.'" alt="'.get_the_title().'">';
			if (!file_exists($new_image_path) && !file_exists($new_image_url)) {
				// Image creation error
				$try_to_create_again = true;
			}
		}
	
		if ((headway_visual_editor_open() && !$leaf['options']['gp-recreate-images']) || $try_to_create_again ) {
	
			// the @ hides the error message
			if (function_exists( 'exif_imagetype' )) {	
				$image_exists = @exif_imagetype($image_path);
			} else {
				$image_exists = @getimagesize($image_path);
			}
			$useloc = 'path';
			if (!$image_exists) {
				$useloc = 'url';
				if (function_exists( 'exif_imagetype' )) {	
					$image_exists = @exif_imagetype($image_url);
				} else {
					$image_exists = @getimagesize($image_url);
				}
				if (!$image_exists) {
					$useloc = 'noimage';
				}					
			}
	
			if (!$image_exists) {
				$image_src = 'Cannot find or access the specified image. Please check you have set a featured image, or post has an imge. Otherwise check the file permissions on your images folders';
			} else {
	
				// Verify memory available.
				// Check source image size . Limit to 2500x2500 
				
				//What's the point of all this though if it's just going to give a different sort of error msg?!
				/// Whjat is we had a setting to increase memory limit…
				
				$memory_ok = true;
				
	/*
				if ($leaf['options']['gp-memory-limit'] != 'none' && $leaf['options']['gp-memory-limit'] != '') {
					if ($useloc == 'url') {
		 				list ($x, $y) = @getimagesize ($image_url);
					} else {
			 			list ($x, $y) = @getimagesize ($image_path);
					}
		 			$memory_needed = ($x * $y * 1.9 * 3) + ($target_width * $target_height * 1.9 * 3);
		 			$total_memory = substr($leaf['options']['gp-memory-limit'],0,-1)*1024*1024;
					$mem_avail = $total_memory-memory_get_usage();
					$memory_ok = ($mem_avail>$memory_needed);
					$suggested = '';
					var_dump($memory_needed,$total_memory,$mem_avail,memory_get_usage());
					//27,33, -1.9,35
				}
	*/
				
//				$new_image_url = HEADWAYURL.'/media'.'/'.HEADWAYCACHEDIR.'/images/gplus-image-'.$image_id.'-leaf-'.$leafid.'.jpg';
//				$new_image_path = HEADWAYCACHE.'/images/gplus-image-'.$image_id.'-leaf-'.$leafid.'.jpg';
				
				if ($memory_ok) {
	
					//---------------------------------------------------------------------------------------------------------------------
					// Run the image processing from Oberto
					//---------------------------------------------------------------------------------------------------------------------
					if ($useloc == 'url') {
						$resizeObj = new gp_resize($image_url);
					} else {
						$resizeObj = new gp_resize($image_path);
					}	
		
					$gp_sizing_type = (!$sizing_type) ? 'crop' : $sizing_type; 
		//			$gp_sizing_type = 'crop'; 
					$resizeObj -> resizeImage($target_width, $target_height, $gp_sizing_type, $vertical_crop_align, $horizontal_crop_align,$img_bg_colour,$centre_image);
			
/*
					if (!is_dir(HEADWAYCACHE.'/images')) {
						mkdir(HEADWAYCACHE.'/images');
					}
*/
			
					
					// Files should alsways exist... so only really need to be created when in Visual Editor...
					if(headway_visual_editor_open() || !file_exists($new_image_path) || $try_to_create_again) {
						if(headway_visual_editor_open()) {
// Can't do this here as VE ends up with only one image per gallery! Fixes in normal page tho.
//							GPFunctions::clear_image_cache( HEADWAYCACHE.'/images','-leaf-'.$leaf['id']);
						}
						$gp_quality = (!$img_quality) ? 70 : (int) $img_quality; 
						$resizeObj -> saveImage($new_image_path, $gp_quality);
					}
				
					if(!file_exists($new_image_path) && !file_exists($new_image_url)) {
						// Image creation error
						// $gp_error['cache'] .= '<div class="ep-errors"><strong>Image cache problem:</strong>.Image '.$new_image_url.' not created. Please check Headway cache folder permissions.</div>';
					}
				} else {
					if (strpos($image_id,'thm')) {
						echo '<div class="gp_warning">Image <strong>'.$image_shortname.'</strong> was too big. WordPress had only <strong>'.round($mem_avail/1024/1024,2).'MB</strong> of <strong>'.round($total_memory/1024/1024,2).'MB</strong>, but needed <strong>'.round($memory_needed/1024/1024,2).'MB</strong> to process this image. You have set a limit of '.$leaf['options']['gp-memory-limit'].'B. <br/>Try a larger limit, or shrinking the image and re-uploading, or increasing the WordPress memory limit.</div>';
					}
					$error_msg1 = "Source image too big";
					$error_msg2 = "to process. Try";
					$error_msg3 = "resizing it smaller";
	
					$im = imagecreate($target_width, $target_height);
	
					// Black on grey
					$bg = imagecolorallocate($im, 240, 240, 240);
					$textcolor = imagecolorallocate($im, 32, 32, 32);
	
					// Write the string at the top left
					imagestring($im, 4, 5, 5, $error_msg1, $textcolor);
					imagestring($im, 4, 5, 20, $error_msg2, $textcolor);
					imagestring($im, 4, 5, 35, $error_msg3, $textcolor);
					imagejpeg($im,$new_image_path);
				}
			}
		}
	
	
		return array('image_url'=>$image_url,'new_image_url'=>$new_image_url);
	}
	
	
	function parse_meta($leaf,$meta){
		global $post;
		global $authordata;
				
		//Date
		if(stripslashes(headway_get_option('post-date-format')) == '1') $date_format = 'F j, Y';
		if(stripslashes(headway_get_option('post-date-format')) == '2') $date_format = 'm/d/y';
		if(stripslashes(headway_get_option('post-date-format')) == '3') $date_format = 'd/m/y';
		if(stripslashes(headway_get_option('post-date-format')) == '4') $date_format = 'M j';
		if(stripslashes(headway_get_option('post-date-format')) == '5') $date_format = 'M j, Y';
		if(stripslashes(headway_get_option('post-date-format')) == '6') $date_format = 'F j';
		if(stripslashes(headway_get_option('post-date-format')) == '7') $date_format = 'F jS';
		if(stripslashes(headway_get_option('post-date-format')) == '8') $date_format = 'F jS, Y';
		if(stripslashes(headway_get_option('post-date-format')) == 'wp') $date_format = false;
		
		$datetime = $date_format ? get_the_time($date_format) : get_the_date();
	
	
		//Coments and Respond
		if(get_comments_number($post->ID) == 0) $comments_format = stripslashes(headway_get_option('post-comment-format-0'));
		if(get_comments_number($post->ID) == 1) $comments_format = stripslashes(headway_get_option('post-comment-format-1'));
		if(get_comments_number($post->ID) > 1) $comments_format = stripslashes(headway_get_option('post-comment-format'));
		
		$comments_format = str_replace('%num%', get_comments_number($post->ID), $comments_format);
		$respond_format = stripslashes(headway_get_option('post-respond-format'));
		
		
		//Set up everything
		$date = '<span class="entry-date published">'.$datetime.'</span>';
		$comments = $comments_format;
		$comments_link = '<a href="'.get_comments_link().'" title="'.get_the_title().' Comments" class="entry-comments">'.$comments.'</a>';
		$respond = '<a href="'.get_permalink().'#respond" title="Respond to '.get_the_title().'" class="entry-respond">'.$respond_format.'</a>';
		$author_no_link = $authordata->display_name;
		$author_avatar = ($leaf['options']['show-avatar'] == true && $leaf['options']['image-location'] != 'behind') ? get_avatar(get_the_author_meta('ID'), $leaf['options']['avatar-size']) : null;
		$author = '<a class="author-link fn nickname url" href="'.get_author_posts_url($authordata->ID).'" title="View all posts by '.$authordata->display_name.'">'.$author_avatar.$authordata->display_name.'</a>';
		$categories = get_the_category_list(', ');
		$tags = (get_the_tags() != NULL) ? get_the_tag_list('<span class="tag-links"><span>Tags:</span> ',', ','</span>') : '';
		$edit = ( current_user_can( 'edit_post', $post->ID ) ) ? '<span class="edit"><a class="post-edit-link" href="' . get_edit_post_link( $post->ID ) . '" title="' . esc_attr( __( 'Edit post' , 'headway') ) . '">Edit</a></span>' : '';
		
		
		//Parse the stuff
		$meta = str_replace('%date%', $date, $meta);
		$meta = str_replace('%comments%', $comments, $meta);
		$meta = str_replace('%comments_link%', $comments_link, $meta);
		$meta = str_replace('%respond%', $respond, $meta);
		$meta = str_replace('%author%', $author, $meta);
		$meta = str_replace('%author_no_link%', $author_no_link, $meta);
		$meta = str_replace('%categories%', $categories, $meta);
		$meta = str_replace('%tags%', $tags, $meta);
		$meta = str_replace('%edit%', $edit, $meta);
		
		return $meta;
	}

	// Pinched this from Clay dude
	function meta_php($meta){
		$content = stripslashes(base64_decode($meta));
		
		//Remove bad MailChimp code.
		$content = str_replace('<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.2.6/jquery.min.js"></script>', '', $meta);
		
		return	headway_parse_php(do_shortcode($meta));
		
	}
	
	function clear_image_cache($path=GP_CACHE_PATH,$match='gplus'){
		$cache_files = scandir($path);
		foreach ($cache_files as $cache_file) {
			if (strpos($cache_file,$match)!==false) {
				unlink($path.'/'.$cache_file);
			}
		}	
	}
	
	//---------------------------------------------------------------------------------------------------
	// Debug
	//---------------------------------------------------------------------------------------------------
	function debug($value=''){ 
	    $btr=debug_backtrace(); 
	    $line=$btr[0]['line']; 
	    $file=basename($btr[0]['file']); 
	    print"<pre>$file:$line</pre>\n"; 
	    if(is_array($value)){ 
	        print"<pre>"; 
	        print_r($value); 
	        print"</pre>\n"; 
	    }elseif(is_object($value)){ 
	       var_dump($value); 
	    }else{ 
	        print("<p>&gt;${value}&lt;</p>"); 
	    } 
	} 

	function wp_attachment_count($post_id, $type = "image") {
	
		$args = array( 'post_type' => 'attachment', 'numberposts' => -1, 'post_status' => null, 'post_parent' => $post_id, 'post_mime_type' => $type); 
		$attachments = get_posts( $args );
		return sizeof($attachments);
	
	}
	
	function check_version() {
		//runs only in admin and user can manage
		// checks online version info
		// Presents download link to latest version
		// Provide link to changelog

		if(!current_user_can('manage_options')) return false;

		$latest_version_array = wp_remote_get('https://s3.amazonaws.com/341public/gpversion.txt', array('timeout' => 2));

		if(is_wp_error($latest_version_array)) return false;
	
		$latest_version = $latest_version_array['body'];
		$is_beta = strpos(GP_VERSION,'b');
		$current_version = ($is_beta) ? substr(GP_VERSION,$is_beta):GP_VERSION;
		$is_new_version = version_compare($latest_version,$current_version,'>');
//		var_dump($current_version,$latest_version,$is_new_version);
		
		if ($is_new_version) {
			if (is_admin_bar_showing()) {echo '<br/>';}
			echo '<div id="update-nag">Gallery+ '.$latest_version.' is available, you\'re running '.GP_VERSION.'! &nbsp;<a href="https://s3.amazonaws.com/341public/headway-leaf-galleryplus-'.str_replace('.','',$latest_version).'.zip">Click here to download</a> or here to view the <a href="https://s3.amazonaws.com/341public/gpchangelog.txt" target="_blank">instructions and change log</a>.</div>';
		}

	}



} //End class

